<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hext_ho.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hext_ho.c</h1><a href="hext__ho_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hext_ho.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00035"></a>00035 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00036"></a>00036 <span class="keyword">static</span> Vec       VHthis;
<a name="l00037"></a>00037 <span class="keyword">static</span> Vec       VMpHext=PETSC_NULL;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">static</span> PetscReal hextamp;     
<a name="l00040"></a>00040 <span class="keyword">static</span> PetscReal hextini;     
<a name="l00041"></a>00041 <span class="keyword">static</span> PetscReal hexttheta;   
<a name="l00042"></a>00042 <span class="keyword">static</span> PetscReal hextphi;     
<a name="l00043"></a>00043 <span class="keyword">static</span> PetscReal hextxyz[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]; 
<a name="l00044"></a>00044 <span class="keyword">static</span> PetscReal hextsweep;   
<a name="l00045"></a>00045 <span class="keyword">static</span> PetscReal hextstep;    
<a name="l00046"></a>00046 <span class="keyword">static</span> PetscReal hextfinal;
<a name="l00047"></a>00047 <span class="keyword">static</span> PetscReal tstart;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">static</span> PetscReal *tfdata=PETSC_NULL;
<a name="l00050"></a>00050 <span class="keyword">static</span> PetscReal *hstep_fdata=PETSC_NULL;
<a name="l00051"></a>00051 <span class="keyword">static</span> PetscReal hstep;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="hext__ho_8c.html#aacac4af746c003dbd608d662ca2272e2">00054</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#aacac4af746c003dbd608d662ca2272e2">MpHext</a>(Vec M,PetscReal *vres)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   assert(VMpHext!=PETSC_NULL);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">/* calculate M//Hext */</span>
<a name="l00061"></a>00061   ierr = VecDot(M,VMpHext,vres);CHKERRQ(ierr);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="hext__ho_8c.html#a386ce6c3aee542bfbdfbc8bce99d51fe">00067</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a386ce6c3aee542bfbdfbc8bce99d51fe">Hext_ho_hstep</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   PetscReal hextnewamp;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00074"></a>00074     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keywordflow">if</span> (hstep_fdata!=PETSC_NULL) {
<a name="l00078"></a>00078     hstep+=1;
<a name="l00079"></a>00079     <span class="comment">/* current field amplitude = initial field * scaling factor */</span>
<a name="l00080"></a>00080     hextnewamp=hextini*<a class="code" href="field_8h.html#aeebb8d32f6d9e3ab71e50c03e1372717">get_scalf_hstep</a>(hstep_fdata,hstep);
<a name="l00081"></a>00081     hextstep=hextnewamp-hextamp;
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((hextstep &lt; 0.0 &amp;&amp; hextamp &lt;= hextfinal) ||
<a name="l00084"></a>00084            (hextstep &gt; 0.0 &amp;&amp; hextamp &gt;= hextfinal)) {
<a name="l00085"></a>00085     ierr = PetscPrintf(PETSC_COMM_WORLD,
<a name="l00086"></a>00086       <span class="stringliteral">&quot;hextamp %g kA/m exceeds hextfinal %g kA/m\n&quot;</span>,
<a name="l00087"></a>00087       hextamp*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0),hextfinal*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0)
<a name="l00088"></a>00088     );
<a name="l00089"></a>00089     gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=99;
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordflow">if</span> (hextstep==0.0) {
<a name="l00093"></a>00093     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   hextamp += hextstep;
<a name="l00097"></a>00097   gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>=0;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="hext__ho_8c.html#a2e1ef17932652e8d616587011fb09c63">00102</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a2e1ef17932652e8d616587011fb09c63">Hext_ho_hsweep</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00103"></a>00103 {
<a name="l00104"></a>00104   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (!fieldon || hextsweep==0) {
<a name="l00107"></a>00107     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00108"></a>00108   }
<a name="l00109"></a>00109   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (hextsweep &lt; 0.0 &amp;&amp; hextamp &lt;= hextfinal) {
<a name="l00110"></a>00110     ierr = PetscPrintf(PETSC_COMM_WORLD,
<a name="l00111"></a>00111       <span class="stringliteral">&quot;hextamp %g kA/m &lt; hextfinal %g kA/m\n&quot;</span>,
<a name="l00112"></a>00112       hextamp*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0),hextfinal*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0)
<a name="l00113"></a>00113     );
<a name="l00114"></a>00114     gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=99;
<a name="l00115"></a>00115   }
<a name="l00116"></a>00116   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (hextsweep &gt; 0.0 &amp;&amp; hextamp &gt;= hextfinal) {
<a name="l00117"></a>00117     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00118"></a>00118       <span class="stringliteral">&quot;hextamp %g kA/m &gt; hextfinal %g kA/m\n&quot;</span>,
<a name="l00119"></a>00119       hextamp*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0),hextfinal*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0)
<a name="l00120"></a>00120     );
<a name="l00121"></a>00121     gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=99;
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123   <span class="keywordflow">else</span> {
<a name="l00124"></a>00124     hextamp = hextini + hextsweep*(gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a> - tstart);
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="hext__ho_8c.html#ad61d58b7779a7d182a09c9becae36af1">00130</a> <span class="keywordtype">int</span> <a class="code" href="hext__ho_8c.html#ad61d58b7779a7d182a09c9becae36af1">Hext_ho_ht_Init</a>()
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keywordtype">int</span> rank,size;
<a name="l00135"></a>00135   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00136"></a>00136   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordtype">char</span>       str[256];
<a name="l00139"></a>00139   PetscTruth flg;
<a name="l00140"></a>00140   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-hext_ho_htfile&quot;</span>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00143"></a>00143     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00144"></a>00144       <span class="stringliteral">&quot;Option -hext_ho_htfile not found, continuing with scaling=1\n&quot;</span>,
<a name="l00145"></a>00145       str
<a name="l00146"></a>00146     );
<a name="l00147"></a>00147     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00148"></a>00148   }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   FILE *fd=PETSC_NULL;
<a name="l00151"></a>00151   <span class="keywordflow">if</span> (!rank) {
<a name="l00152"></a>00152     ierr = PetscFOpen(PETSC_COMM_WORLD,str,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00153"></a>00153     <span class="keywordflow">if</span> (!fd){
<a name="l00154"></a>00154       SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,str);
<a name="l00155"></a>00155     }
<a name="l00156"></a>00156   }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   ierr = <a class="code" href="ipol_8c.html#a7c6add33a29c7ae759615a08798ee75d">readht</a>(fd,&amp;tfdata,2);CHKERRQ(ierr);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="hext__ho_8c.html#aed1404d744513b58ba58166a487dcbdf">00165</a> <span class="keywordtype">int</span> <a class="code" href="hext__ho_8c.html#aed1404d744513b58ba58166a487dcbdf">Hext_ho_hstep_Init</a>()
<a name="l00166"></a>00166 {
<a name="l00167"></a>00167   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordtype">int</span> rank;
<a name="l00170"></a>00170   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="keywordtype">char</span> str[256];
<a name="l00173"></a>00173   PetscTruth flg;
<a name="l00174"></a>00174   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-hext_ho_hstepfile&quot;</span>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00177"></a>00177     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00178"></a>00178       <span class="stringliteral">&quot;Option -hext_ho_hstepfile not found, continuing with scaling=1\n&quot;</span>,
<a name="l00179"></a>00179       str
<a name="l00180"></a>00180     );
<a name="l00181"></a>00181     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   FILE *fd=PETSC_NULL;
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (!rank) {
<a name="l00186"></a>00186     ierr = PetscFOpen(PETSC_COMM_WORLD,str,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00187"></a>00187     <span class="keywordflow">if</span> (!fd){
<a name="l00188"></a>00188       SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,str);
<a name="l00189"></a>00189     }
<a name="l00190"></a>00190   }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   ierr = <a class="code" href="field_8h.html#a567e7efd2748f5b33963b581ed12626c">read_hstep_file</a>(fd,&amp;hstep_fdata,2);CHKERRQ(ierr);
<a name="l00193"></a>00193   hstep = 0;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a><a class="code" href="hext__ho_8c.html#aa7f4b51477b5dcd5afd1f4b73ffde571">00201</a> <span class="keywordtype">int</span> <a class="code" href="hext__ho_8c.html#aa7f4b51477b5dcd5afd1f4b73ffde571">Hext_ho_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00202"></a>00202 {
<a name="l00203"></a>00203   PetscTruth   flg;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hextini&quot;</span>,&amp;hextini,&amp;flg);CHKERRQ(ierr);
<a name="l00208"></a>00208   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00209"></a>00209     hextini=0;
<a name="l00210"></a>00210     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00211"></a>00211       <span class="stringliteral">&quot;Option -hextini not found. Using default value %g\n&quot;</span>,
<a name="l00212"></a>00212       hextini
<a name="l00213"></a>00213     );
<a name="l00214"></a>00214   }
<a name="l00215"></a>00215   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-htheta&quot;</span>,&amp;hexttheta,&amp;flg);CHKERRQ(ierr);
<a name="l00216"></a>00216   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00217"></a>00217     hexttheta=0;
<a name="l00218"></a>00218     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00219"></a>00219       <span class="stringliteral">&quot;Option -htheta not found. Using default value %g\n&quot;</span>,
<a name="l00220"></a>00220       hexttheta
<a name="l00221"></a>00221     );
<a name="l00222"></a>00222   }
<a name="l00223"></a>00223   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hphi&quot;</span>,&amp;hextphi,&amp;flg);CHKERRQ(ierr);
<a name="l00224"></a>00224   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00225"></a>00225     hextphi=0;
<a name="l00226"></a>00226     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00227"></a>00227       <span class="stringliteral">&quot;Option -hphi not found. Using default value %g\n&quot;</span>,
<a name="l00228"></a>00228       hextphi
<a name="l00229"></a>00229     );
<a name="l00230"></a>00230   }
<a name="l00231"></a>00231   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hstep&quot;</span>,&amp;hextstep,&amp;flg);CHKERRQ(ierr);
<a name="l00232"></a>00232   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00233"></a>00233     hextstep=0;
<a name="l00234"></a>00234     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00235"></a>00235       <span class="stringliteral">&quot;Option -hstep not found. Using default value %g\n&quot;</span>,
<a name="l00236"></a>00236       hextstep
<a name="l00237"></a>00237     );
<a name="l00238"></a>00238   }
<a name="l00239"></a>00239   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hsweep&quot;</span>,&amp;hextsweep,&amp;flg);CHKERRQ(ierr);
<a name="l00240"></a>00240   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00241"></a>00241     hextsweep=0;
<a name="l00242"></a>00242     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00243"></a>00243       <span class="stringliteral">&quot;Option -hsweep not found. Using default value %g\n&quot;</span>,
<a name="l00244"></a>00244       hextsweep
<a name="l00245"></a>00245     );
<a name="l00246"></a>00246   }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   <span class="keywordflow">if</span> (PetscAbsReal(hextstep)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a> &amp;&amp; PetscAbsReal(hextsweep)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00249"></a>00249     SETERRQ(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;hstep and hsweep != 0.0\n&quot;</span>);
<a name="l00250"></a>00250   }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==1 &amp;&amp; PetscAbsReal(hextsweep)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00253"></a>00253     SETERRQ(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;mode == 1 and hsweep != 0.0\n&quot;</span>);
<a name="l00254"></a>00254   }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   hextxyz[0]=sin(hexttheta)*cos(hextphi);
<a name="l00257"></a>00257   hextxyz[1]=sin(hexttheta)*sin(hextphi);
<a name="l00258"></a>00258   hextxyz[2]=cos(hexttheta);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">/* create VMpHext */</span>
<a name="l00261"></a>00261   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VMpHext);CHKERRQ(ierr);
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   PetscReal *ta_elevol;
<a name="l00264"></a>00264   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_elevol);CHKERRQ(ierr);
<a name="l00265"></a>00265   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00266"></a>00266     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>; j++) {
<a name="l00267"></a>00267       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; k++) {
<a name="l00268"></a>00268         PetscReal matele;
<a name="l00269"></a>00269         matele=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4]*ta_elevol[i]/NV*hextxyz[k];
<a name="l00270"></a>00270         ierr = VecSetValue(
<a name="l00271"></a>00271           VMpHext,
<a name="l00272"></a>00272           ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]+k,
<a name="l00273"></a>00273           matele,
<a name="l00274"></a>00274           ADD_VALUES
<a name="l00275"></a>00275         );CHKERRQ(ierr);
<a name="l00276"></a>00276       }
<a name="l00277"></a>00277     }
<a name="l00278"></a>00278   }
<a name="l00279"></a>00279   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_elevol);CHKERRQ(ierr);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   ierr = VecAssemblyBegin(VMpHext);CHKERRQ(ierr);
<a name="l00282"></a>00282   ierr = VecAssemblyEnd(VMpHext);CHKERRQ(ierr);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   PetscReal Javg, matele;
<a name="l00285"></a>00285   ierr = VecSum(VMpHext,&amp;matele);CHKERRQ(ierr);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   ierr = VecSum(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;Javg);CHKERRQ(ierr);
<a name="l00288"></a>00288   Javg /= <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00289"></a>00289   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;average magnetization: %g T\n&quot;</span>,Javg*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>);
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00292"></a>00292     <span class="stringliteral">&quot;Javg: %g  vol: %g  matele: %g  matele/vol: %g\n&quot;</span>,
<a name="l00293"></a>00293     Javg,
<a name="l00294"></a>00294     gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>,
<a name="l00295"></a>00295     matele,
<a name="l00296"></a>00296     matele/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>
<a name="l00297"></a>00297   );
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   Javg = 1.0/(Javg*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>);
<a name="l00300"></a>00300   ierr = VecScale(VMpHext,Javg);CHKERRQ(ierr);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="keywordflow">if</span> (hextini==0.0 &amp;&amp; hextstep==0.0 &amp;&amp; hextsweep==0.0) {
<a name="l00303"></a>00303     fieldon=0;
<a name="l00304"></a>00304     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00305"></a>00305       <span class="stringliteral">&quot;Options -hextini, -hextstep, and -hextsweep == 0 (field off).\n&quot;</span>
<a name="l00306"></a>00306     );
<a name="l00307"></a>00307     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_ho off\n&quot;</span>);
<a name="l00308"></a>00308     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00309"></a>00309   }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   fieldon=1;
<a name="l00312"></a>00312   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_ho on\n&quot;</span>);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hfinal&quot;</span>,&amp;hextfinal,&amp;flg);CHKERRQ(ierr);
<a name="l00315"></a>00315   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00316"></a>00316     hextfinal=0;
<a name="l00317"></a>00317     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00318"></a>00318       <span class="stringliteral">&quot;Option -hfinal not found. Using default value %i\n&quot;</span>,
<a name="l00319"></a>00319       hextfinal
<a name="l00320"></a>00320     );
<a name="l00321"></a>00321   }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHthis);CHKERRQ(ierr);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="comment">/* convert from kA/m to SI units A/m */</span>
<a name="l00327"></a>00327   hextini   *= 1000.0;
<a name="l00328"></a>00328   hextstep  *= 1000.0;
<a name="l00329"></a>00329   hextfinal *= 1000.0;
<a name="l00330"></a>00330   hextsweep *= 1000.0;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   PetscPrintf(MPI_COMM_WORLD,
<a name="l00333"></a>00333     <span class="stringliteral">&quot;Hext:\n&quot;</span>
<a name="l00334"></a>00334     <span class="stringliteral">&quot;theta: %g rad = %g deg    phi: %g rad = %g deg\n&quot;</span>
<a name="l00335"></a>00335     <span class="stringliteral">&quot;e_H: (%g, %g, %g)\n&quot;</span>
<a name="l00336"></a>00336     <span class="stringliteral">&quot;|Hini|: %g A/m = %g T\n&quot;</span>
<a name="l00337"></a>00337     <span class="stringliteral">&quot;Hini: (%g, %g, %g) T\n&quot;</span>
<a name="l00338"></a>00338     <span class="stringliteral">&quot;Hstep: %g A/m = %g T\n&quot;</span>
<a name="l00339"></a>00339     <span class="stringliteral">&quot;Hsweep: %g A/(m*ns) = %g T/ns\n&quot;</span>
<a name="l00340"></a>00340     <span class="stringliteral">&quot;hextfinal: %g A/m = %g T\n&quot;</span>,
<a name="l00341"></a>00341     hexttheta,hexttheta*180.0/PETSC_PI,
<a name="l00342"></a>00342     hextphi,  hextphi*180.0/PETSC_PI,
<a name="l00343"></a>00343     hextxyz[0],hextxyz[1],hextxyz[2],
<a name="l00344"></a>00344     hextini,  hextini*<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>,
<a name="l00345"></a>00345     hextxyz[0]*hextini*MU0,hextxyz[1]*hextini*MU0,hextxyz[2]*hextini*MU0,
<a name="l00346"></a>00346     hextstep, hextstep*MU0,
<a name="l00347"></a>00347     hextsweep,hextsweep*MU0,
<a name="l00348"></a>00348     hextfinal,hextfinal*MU0
<a name="l00349"></a>00349   );
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="comment">/* rescale external field */</span>
<a name="l00352"></a>00352   hextini   /= gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/MU0;
<a name="l00353"></a>00353   hextamp=hextini;
<a name="l00354"></a>00354   hextstep  /= gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/MU0;
<a name="l00355"></a>00355   hextfinal /= gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/MU0;
<a name="l00356"></a>00356   hextsweep /= gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(1e9*MU0*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   PetscPrintf(MPI_COMM_WORLD,
<a name="l00359"></a>00359     <span class="stringliteral">&quot;Hext_scaled:\n&quot;</span>
<a name="l00360"></a>00360     <span class="stringliteral">&quot;Hini: %g\n&quot;</span>
<a name="l00361"></a>00361     <span class="stringliteral">&quot;Hstep: %g\n&quot;</span>
<a name="l00362"></a>00362     <span class="stringliteral">&quot;Hsweep: %g\n&quot;</span>
<a name="l00363"></a>00363     <span class="stringliteral">&quot;Hfinal: %g\n&quot;</span>,
<a name="l00364"></a>00364     hextini,
<a name="l00365"></a>00365     hextstep,
<a name="l00366"></a>00366     hextsweep,
<a name="l00367"></a>00367     hextfinal
<a name="l00368"></a>00368   );
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   <span class="comment">/* larmor frequency in external field */</span>
<a name="l00371"></a>00371   <span class="keywordflow">if</span> (hextini &gt; <a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00372"></a>00372     PetscReal  t_larmorf2;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374     t_larmorf2=<a class="code" href="griddata_8h.html#a8659b9de3e544ff142b153b076f30fd5">GAMMA</a>/MU0*hextini;
<a name="l00375"></a>00375     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;f_Larmor_ext: %g GHz -&gt; T=1/f=%g ns\n&quot;</span>,t_larmorf2/(2.0*PETSC_PI*1e9),1.0/(t_larmorf2/(2.0*PETSC_PI*1e9)));
<a name="l00376"></a>00376   }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   tstart=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   ierr = <a class="code" href="hext__ho_8c.html#ad61d58b7779a7d182a09c9becae36af1">Hext_ho_ht_Init</a>();CHKERRQ(ierr);
<a name="l00381"></a>00381   ierr = <a class="code" href="hext__ho_8c.html#aed1404d744513b58ba58166a487dcbdf">Hext_ho_hstep_Init</a>();CHKERRQ(ierr);
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a><a class="code" href="hext__ho_8c.html#aeb00096e7649b4910f8fa67dc6f27401">00387</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#aeb00096e7649b4910f8fa67dc6f27401">Hext_ho</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHextsum,PetscReal *hext)
<a name="l00388"></a>00388 {
<a name="l00389"></a>00389   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   <span class="comment">/* initialize if necessary */</span>
<a name="l00392"></a>00392   <span class="keywordflow">if</span> (doinit) {
<a name="l00393"></a>00393     ierr = <a class="code" href="hext__ho_8c.html#aa7f4b51477b5dcd5afd1f4b73ffde571">Hext_ho_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00394"></a>00394     doinit=0;
<a name="l00395"></a>00395   }
<a name="l00396"></a>00396   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00397"></a>00397     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00398"></a>00398   }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="comment">/* get time in nanoseconds */</span>
<a name="l00401"></a>00401   PetscReal nstime;
<a name="l00402"></a>00402   nstime=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9;
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="keywordflow">if</span> (tfdata!=PETSC_NULL) {
<a name="l00405"></a>00405     <span class="comment">/* current field amplitude =  initial field * scaling factor */</span>
<a name="l00406"></a>00406     hextamp=hextini*<a class="code" href="ipol_8c.html#a3e2699b016b84132ec08d3795b951dd9">getscalf</a>(tfdata,nstime);
<a name="l00407"></a>00407   }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   <span class="keywordflow">if</span> (PetscAbsReal(hextsweep)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00410"></a>00410     ierr = <a class="code" href="field_8h.html#a2e1ef17932652e8d616587011fb09c63">Hext_ho_hsweep</a>(gdata);CHKERRQ(ierr);
<a name="l00411"></a>00411   }
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="keyword">static</span> PetscReal hextampbak=PETSC_MAX;
<a name="l00414"></a>00414   <span class="keyword">static</span> PetscReal hextxyzbak[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]={PETSC_MAX,PETSC_MAX,PETSC_MAX};
<a name="l00415"></a>00415   <span class="keywordflow">if</span> (hextxyz[0]!=hextxyzbak[0] ||
<a name="l00416"></a>00416       hextxyz[1]!=hextxyzbak[1] ||
<a name="l00417"></a>00417       hextxyz[2]!=hextxyzbak[2] ||
<a name="l00418"></a>00418       hextamp!=hextampbak) {
<a name="l00419"></a>00419 
<a name="l00420"></a>00420     ierr = <a class="code" href="util_8h.html#aa88f92d349ee3335807573e6ff373963">VecSetVec</a>(VHthis,hextxyz,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00421"></a>00421     hextxyzbak[0]=hextxyz[0];
<a name="l00422"></a>00422     hextxyzbak[1]=hextxyz[1];
<a name="l00423"></a>00423     hextxyzbak[2]=hextxyz[2];
<a name="l00424"></a>00424 
<a name="l00425"></a>00425     ierr = VecScale(VHthis,hextamp);CHKERRQ(ierr);
<a name="l00426"></a>00426     hextampbak=hextamp;
<a name="l00427"></a>00427   }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   ierr = VecAXPY(VHextsum,1.0,VHthis);CHKERRQ(ierr);
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   *hext=hextamp;
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00434"></a>00434 }
<a name="l00435"></a>00435 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

